Detect errors correctly from dcpinfo.
[libdcp.git] / run / tests
1 #!/bin/bash
2 #
3 # Run our test suite.
4
5 # Private test data; this is stuff that is non-distributable
6 private=../libdcp1-test-private
7 # Work directory
8 work=build/test
9 # Path to dcpinfo tool
10 dcpinfo=build/tools/dcpinfo
11
12 export LD_LIBRARY_PATH=build/src:build/asdcplib/src:$LD_LIBRARY_PATH
13
14 # Make sure we have the required tools
15 for c in xmlsec1 xmldiff; do
16   hash $c 2>/dev/null || { echo >&2 "$c required but not found; aborting"; exit 1; }
17 done
18
19 # Run the unit tests in test/
20 if [ "$1" == "--debug" ]; then
21     shift
22     gdb --args $work/tests $private
23 elif [ "$1" == "--valgrind" ]; then
24     shift
25     valgrind --tool="memcheck" $work/tests $private
26 elif [ "$1" == "--callgrind" ]; then
27     shift
28     valgrind --tool="callgrind" $work/tests $private $*
29 else
30     $work/tests $private $*
31 fi
32
33 # Check a MXF written by the unit tests
34 diff $work/baz/video1.mxf $work/baz/video2.mxf
35 if [ "$?" != "0" ]; then
36     echo "FAIL: MXFs from recovery incorrect"
37     exit 1
38 fi
39
40 # Check the DCP written by dcp_test1
41 diff -ur test/ref/DCP/dcp_test1 $work/DCP/dcp_test1
42 if [ "$?" != "0" ]; then
43     echo "FAIL: files differ"
44     exit 1
45 fi
46
47 # Check the DCP written by dcp_test2
48 diff -ur test/ref/DCP/dcp_test2 $work/DCP/dcp_test2
49 if [ "$?" != "0" ]; then
50     echo "FAIL: files differ"
51     exit 1
52 fi
53
54 # Check the DCP written by encryption_test
55 diff -ur test/ref/DCP/encryption_test $work/DCP/encryption_test
56 if [ "$?" != "0" ]; then
57     echo "FAIL: files differ"
58     exit 1
59 fi
60
61 # Everything beyond this point needs $private to exist
62 if [ ! -e "$private/info.log" ]; then
63     echo ""
64     echo "Private data not found: some tests will not run."
65     exit 1
66 fi
67
68 # Run dcpinfo on all the DCPs in private/metadata, writing $work/info.log
69 # This writes details of the CPLs and all subtitle details, so it checks
70 # if the code is reading subtitle files correctly.
71 rm -f $work/info.log
72 for d in `find $private/metadata -mindepth 1 -maxdepth 1 -type d | sort -f -d`; do
73     if [ `basename $d` != ".git" ]; then
74         $dcpinfo --ignore-missing-assets -k -s $d >> $work/info.log
75         if [ "$?" != "0" ]; then
76             echo "FAIL: dcpinfo failed for $d"
77             exit 1
78         fi
79     fi
80 done
81
82 # Check info.log is what it should be
83 diff -q $work/info.log $private/info.log
84 if [ "$?" != "0" ]; then
85     echo "FAIL: dcpinfo output incorrect"
86     exit 1
87 fi
88
89 # Copy $private into build/ then re-write the subtitles of every DCP using
90 # $work/rewrite_subs.  This tests round-trip of subtitle reading/writing.
91 # Note that all the subs in $private/metadata are Interop.
92 rm -f $work/info2.log
93 rm -rf $work/private
94 mkdir $work/private
95 cp -r $private/* $work/private
96 for d in `find $work/private/metadata -mindepth 1 -maxdepth 1 -type d | sort -f -d`; do
97     if [ `basename $d` != ".git" ]; then
98         $work/rewrite_subs $d
99         $dcpinfo --ignore-missing-assets -k -s $d >> $work/info2.log
100     fi
101 done
102
103 # Fudge the output
104 sed -i "s/DCP: build\/test/DCP: test/g" $work/info2.log
105
106 # And check it
107 diff -q $work/info2.log $private/info2.log
108 if [ "$?" != "0" ]; then
109     echo "FAIL: dcpinfo output from rewrite incorrect"
110     exit 1
111 fi
112
113 # Dump the subs of JourneyToJah... (which has MXF-wrapped SMPTE subtitles)
114 # and check that they are right
115 $dcpinfo -s $private/data/JourneyToJah_TLR-1_F_EN-DE-FR_CH_51_2K_LOK_20140225_DGL_SMPTE_OV >> $work/jah.log
116
117 # Parse some problematic subs and check that we get it right
118 run/test/subs_in_out $private/TunaBoat_Icelandic_Reel1_V1_8sec.xml > $work/tuna.xml
119 diff -q $private/TunaBoat_Icelandic_Reel1_V1_8sec.parsed.xml $work/tuna.xml
120 if [ "$?" != "0" ]; then
121     echo "FAIL: output of parse check 1 invalid"
122     exit 1
123 fi
124
125 echo "PASS"